CAPAMovies/src/CAPAMovies/Controllers/MoviesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using CAPAMovies.Data;
using CAPAMovies.Models;
using CAPAMovies.Models.MovieViewModels;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using Microsoft.EntityFrameworkCore.Internal;
using Newtonsoft.Json;

namespace CAPAMovies.Controllers
{
    [RequireHttps]
    [Authorize]
    public class MoviesController : Controller
    {
        private readonly IRepository _context; // Provides access to the custom added tables
        private readonly UserManager<ApplicationUser> _manager; // Provides access to the user information

        public ViewResult UsersList() => View(_context.Users.OrderBy(u => u.Email));
        public ViewResult FormatsList() => View(_context.Formats);
        public ViewResult MoviesList() => View(_context.Movies);
        public ViewResult UserMoviesList() => View(_context.UserMovies);

        public MoviesController(IRepository context, UserManager<ApplicationUser> manager)
        {
            _context = context;
            _manager = manager;
        }

        // GET: Movies
        public ViewResult Index(string SearchString, string sortOrder)
        {
            ViewData["TitleSort"] = String.IsNullOrEmpty(sortOrder) ? "title_desc" : "";
            ViewData["FormatSort"] = sortOrder == "Format" ? "format_desc" : "Format";
            ViewData["DateSort"] = sortOrder == "DateAdded" ? "date_desc" : "DateAdded";
            ViewData["StarSort"] = sortOrder == "StarRating" ? "star_desc" : "StarRating";
            ViewData["LocationSort"] = sortOrder == "Location" ? "location_desc" : "Location";
            ViewData["CustomSort"] = sortOrder == "Custom" ? "custom_desc" : "Custom";
            // Get a list of movies the user has and pass it to the view
            var userId = _manager.GetUserId(User);


            IEnumerable<UserMovie> UserMovieList = _context.UserMovies.Where(s => s.UserID == userId);
            List<Movie> mymovies = new List<Movie>();

 
            foreach(UserMovie mov in UserMovieList)
            {
                mymovies.Add((_context.Movies.SingleOrDefault(s => s.ID == mov.MovieID)));
            }
            IEnumerable<Movie> movies = mymovies;
            IEnumerable<Format> formats = _context.Formats;
            ViewBag.Movies = movies;
            ViewBag.Formats = formats;
            ViewBag.SearchString = SearchString;
            

            switch (sortOrder)
            {
                case "title_desc":
                    UserMovieList = UserMovieList.OrderByDescending(o => o.TitleSort);
                    break;
                case "format_desc":
                    UserMovieList = UserMovieList.OrderByDescending(o => o.FormatID);
                    break;
                case "date_desc":
                    UserMovieList = UserMovieList.OrderByDescending(o => o.DateAdded);
                    break;
                case "star_desc":
                    UserMovieList = UserMovieList.OrderByDescending(o => o.StarRating);
                    break;
                case "location_desc":
                    UserMovieList = UserMovieList.OrderByDescending(o => o.Location);
                    break;
                case "custom_desc":
                    UserMovieList = UserMovieList.OrderByDescending(o => o.Custom);
                    break;
                case "Format":
                    UserMovieList = UserMovieList.OrderBy(o => o.FormatID);
                    break;
                case "DateAdded":
                    UserMovieList = UserMovieList.OrderBy(o => o.DateAdded);
                    break;
                case "StarRatine":
                    UserMovieList = UserMovieList.OrderBy(o => o.StarRating);
                    break;
                case "Location":
                    UserMovieList = UserMovieList.OrderBy(o => o.Location);
                    break;
                case "Custom":
                    UserMovieList = UserMovieList.OrderBy(o => o.Custom);
                    break;
                default:
                    UserMovieList = UserMovieList.OrderBy(o => o.TitleSort);
                    break;
            }
            if (!string.IsNullOrEmpty(SearchString))
            {
                UserMovieList = UserMovieList.Where(s => s.TitleSort.ToUpper().Contains(SearchString.ToUpper()));
            }
            return View(UserMovieList);
        }

        // GET: Movies/Details
        public async Task<IActionResult> Details(string id)
        {
            id = id ?? Request.Query["movieID"];
            //TODO: Update this and view to show usermovie customizations and movie specifications
            if (String.IsNullOrEmpty(id))
            {
                // id was not passed
                return NotFound();
            }
            var currentuser = _manager.GetUserId(User);
            var userMovie =  _context.UserMovies.SingleOrDefault(m => m.MovieID == id && m.UserID == currentuser);
            var movie = _context.Movies.SingleOrDefault(m => m.ID == id);
            var myMovieDetails = await GetMovieDetailsAsync(movie.ID, false); //Get full movie plot length

            if (movie == null || myMovieDetails == null)
            {
                return NotFound();
            }
            var movieDetailsObj = JsonConvert.DeserializeObject<MovieDetails>(myMovieDetails);
            movieDetailsObj.myMovie = movie;
            movieDetailsObj.myUserMovie = userMovie;

            return View(movieDetailsObj);
        }

        /* Search for a movie to add to user's inventory */
        [HttpGet]
        public ViewResult Search()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Search([Bind("ID, Title, Year, PicLink")] Movie movie)
        {
            if (ModelState.IsValid)
            {
                if (!_context.Movies.Any(m => m.ID == movie.ID))
                {
                    _context.Add(movie);
                    await _context.SaveChangesAsync();
                }

                Format format = _context.Formats.SingleOrDefault(m => m.FormatName == "None");
                IEnumerable<Format> formats = _context.Formats;

                ViewBag.Movie = movie;
                ViewBag.UserMovie = new UserMovie(_manager.GetUserId(User), movie.ID, format.ID) {DateAdded = DateTime.Today.ToUniversalTime().AddHours(-8)};
                ViewBag.Formats = formats;
                return View("Create");
            }
            else
            {
                // there is a validation error
                return View();
            }
        }

        [HttpGet]
        public ViewResult Create()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("UserID, MovieID, FormatID, TitleSort, DateAdded, StarRating, Location, Custom, LoanedTo")] UserMovie usermovie)
        {
            //Make sure the user selected a format
            var format = _context.Formats.SingleOrDefault(m => m.FormatName == "None");
            if (usermovie.FormatID == format.ID)
            {
                ViewBag.Movie = _context.Movies.SingleOrDefault(m => m.ID == usermovie.MovieID);
                ViewBag.UserMovie = usermovie;
                ViewBag.Formats = _context.Formats;
                return View(usermovie);
            }

            //Make sure the user doesn't have that movie in the selected format
            if (_context.UserMovies.Any(m => m.MovieID == usermovie.MovieID
                                              && m.UserID == _manager.GetUserId(User)
                                              && m.FormatID == usermovie.FormatID))
            {
                ViewBag.Movie = _context.Movies.SingleOrDefault(m => m.ID == usermovie.MovieID);
                ViewBag.UserMovie = usermovie;
                ViewBag.Formats = _context.Formats;
                return View();
            }
            else
            {
                _context.Add(usermovie);
                await _context.SaveChangesAsync();
            }

            return RedirectToAction("Index");
        }
        

        // GET: Movies/Edit/5
        public IActionResult Edit(string id)
        {
            id = id ?? Request.Query["movieID"];

            string formatQueryID;
            formatQueryID = Request.Query["formatID"];

            int formatID = Convert.ToInt32(formatQueryID);
            if (String.IsNullOrEmpty(id))
            {
                return NotFound();
            }
            var movie = _context.Movies.SingleOrDefault(m => m.ID == id);
            if (movie == null)
            {
                return NotFound();
            }

            Format format = _context.Formats.SingleOrDefault(m => m.FormatName == "None");
            IEnumerable<Format> formats = _context.Formats;

            var userId = _manager.GetUserId(User);
            ViewBag.Movie = movie;
            ViewBag.UserMovie = _context.UserMovies.SingleOrDefault(s => (s.UserID == userId) &&
                                                                         (s.MovieID == movie.ID) &&
                                                                         (s.FormatID == formatID));
            ViewBag.Formats = formats;
            return View("Edit");
        }

        // POST: Movies/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]

CAPAMovies/src/CAPAMovies/Views/Shared/_Layout.cshtml
@using Microsoft.AspNetCore.Identity
@inject SignInManager<ApplicationUser> SignInManager

<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - CAPA Movies</title>
    <link rel="icon"
          type="image/png"
          href="~/images/LOGO.png">

    <environment names="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
        

    </environment>
    <environment names="Staging,Production">
        <link rel="stylesheet" href="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.6/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
</head>
<body>
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                
                <img alt="CAPA" class ="img-circle" style="max-width:30px; padding-top:10px;" src="/images/LOGO.png"/>
                
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>

            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li>@if (SignInManager.IsSignedIn(User))
                        {
                            @if (User.IsInRole("Admin"))
                            {
                                <a asp-area="" asp-controller="Movies" asp-action="UsersList">Users</a>
                            }
                            else
                            {
                                <a asp-area="" asp-controller="Movies" asp-action="Index">My Movies</a>
                            }
                    }
                    </li>
                    <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                    <li><a asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                    <li><a asp-area="" asp-controller="Home" asp-action="Contact">Contact</a></li>
                </ul>
                @await Html.PartialAsync("_LoginPartial")
            </div>
        </div>
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @System.DateTime.Today.Year - CAPA Movies</p>
            @if (DateTime.Now.ToUniversalTime().AddHours(-8) < new DateTime(2017, 6, 5, 18, 0, 0))
            {
                <h4>UNDER CONSTRUCTION</h4>
                <ul>Presentation: 6 June 2017</ul>
            }
        </footer>
    </div>

    <environment names="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
    </environment>
    <environment names="Staging,Production">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-2.2.0.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.6/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("scripts", required: false)
</body>
</html>

CAPAMovies/src/CAPAMovies/Views/Shared/_OMDBapiImports.cshtml
<environment names="Development">
    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/js/OmdbAPI.js"></script>
    <script src="~/lib/jquery-validation/dist/jquery.validate.js"></script>
    <script src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.js"></script>
</environment>
<environment names="Staging,Production">
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/js/OmdbAPI.js"></script>
    <script src="https://ajax.aspnetcdn.com/ajax/jquery.validate/1.14.0/jquery.validate.min.js"
            asp-fallback-src="~/lib/jquery-validation/dist/jquery.validate.min.js"
            asp-fallback-test="window.jQuery && window.jQuery.validator">
    </script>
    <script src="https://ajax.aspnetcdn.com/ajax/jquery.validation.unobtrusive/3.2.6/jquery.validate.unobtrusive.min.js"
            asp-fallback-src="~/lib/jquery-validation-unobtrusive/jquery.validate.unobtrusive.min.js"
            asp-fallback-test="window.jQuery && window.jQuery.validator && window.jQuery.validator.unobtrusive">
    </script>
</environment>